/*Relative Searcher v.2.1
by Griffin Knodle, a.k.a. Jair, 8/26/98
E-mail: gknodle@trinity.edu
http://www.resnet.trinity.edu/users/gknodle/

TERMS OF USE

This program is distributed with its source code. You may use,
distribute, and modify it freely. Only two restrictions: These terms of use 
must stay the same, and you must always include the source code with the
program. Oh, and I'd appreciate it if you credit me as the original
author.*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <conio.h>

int hexInput(int*);

void main(){
  char fileName[40];
  char read[256];
  char lastRead[11];
  int x;
  int input[11];
  int rel[10];
  int first[10];
  int second[10];
  int skipFlag[11];
  int relCount;
  int searchLength;
  int file;
  int check;
  int block;
  int pos;
  int match;

  printf("Relative Search, v.2.0, by Griffin Knodle\n\n");

  printf("Enter name of file to search:");
  fscanf(stdin,"%s",fileName);

  file=open(fileName,O_RDONLY);
  if(file==-1){
    printf("Error opening!");
    exit(1);
    }

  printf("\nNow enter values.\n(enter=done)\n(*=skip this byte)\n(h=");
  printf("force hexadecimal number)\n\n");

  for(x=0;x<11;x++){
    printf("Byte %d:",x);
    input[x]=hexInput(&skipFlag[x]);
    if(skipFlag[x]==1) break;
    }

  // x=number of inputs

  while(skipFlag[x-1]==2 && x > 0){ // No sense having wildcards at the end
    x--;
    }

  while(skipFlag[0]==2 && x > 0){ // or the beginning
    for(pos=0; pos < x-1; pos++){
      input[pos]=input[pos+1];
      skipFlag[pos]=skipFlag[pos+1];
      }
    x--;
    }

  if(x<2){
    printf("\nYou need at least two values for a relative search!\n");
    exit(1);
    }

  searchLength=x;
  relCount=x-1;

  // make relative search table
  pos=0;
  for(x=0; x < relCount; x++){
    first[x]=pos;
    while(skipFlag[pos+1]==2){
      pos++;
      relCount--;
      }
    second[x]=pos+1;
    rel[x]=input[second[x]]-input[first[x]];
    pos++;
    }

  block=0;
  match=0;

  printf("\nSearch:\n");
  for(x=0;x<relCount;x++){
    printf("     Byte %d to byte %d: %+d\n",first[x],second[x],rel[x]);
    }
  printf("\n");

  begin:

  check=_read(file,read,256);

  //printf("Check:%d\n",check);

  if(check==0){
    printf("End of file!\n");
    close(file);
    exit(0);
    }
  if(block==0 && check<searchLength){
    printf("File not long enough!\n");
    exit(1);
    }

  for(pos=0; pos<check; pos++){
    //printf("Checking %s\n",lastRead);
    if(block==0 && pos==0){
      for(x=0; x < searchLength; x++){
	lastRead[x]=read[x];
	}
      pos=searchLength-1;
      }
    if(pos==0)
      lastRead[searchLength-1]=read[0];
    for(x=0; x<relCount; x++){
      if(lastRead[second[x]]-lastRead[first[x]] == rel[match]){ // Match
        match++;
        if(match==relCount){
	  printf("Match at ");
	  printf("%ld",(long int) block*256 + pos - searchLength + 1);
	  printf(" (%lXh)\n",(long int) block*256 + pos - searchLength + 1);
	  match=0;
	  }
        }
      else{
        match=0;
	break;
        }
      }
    for(x=0; x < searchLength-1; x++)
      lastRead[x]=lastRead[x+1];

    if(pos+1 < check)
      lastRead[searchLength-1]=read[pos+1];
    }

  block++;
  goto begin;
 
  }

int hexInput(int* flag){
  int value=0;
  char hexFlag=0;
  char negFlag=0;
  char input[10];
  int charsRead=0;
  int x;

  *flag=0;

  for(charsRead=0; ; charsRead++){

  input[charsRead]=getch();

  if(input[charsRead]==13 && charsRead > 0){
    printf("\n");
    break; // enter
    }

  if(input[charsRead]==13){
    printf("Done\n");
    *flag=1; // done
    return 0;
    }
  if(input[charsRead]=='*' && charsRead == 0){
    printf("*\n");
    *flag=2; // wildcard
    return 0;
    }

  if(input[charsRead]==8){ //backspace
    charsRead--;
    if(charsRead==-1 && negFlag==1){
      negFlag=0;
      printf("%c",8);
      }
    if(charsRead==-1) continue; //not if nothing to erase
    if(hexFlag==1) hexFlag=0; // erase H
    else{ // or erase last digit
      charsRead--;
      }
    printf("%c",8);
    continue;
    }
     
  if(hexFlag==1){ // after typing H, only backspace or enter
    charsRead--;
    continue;
    }

  if(input[charsRead]=='h' || input[charsRead]=='H'){  // set H
    charsRead--;
    if(charsRead==-1) continue; // not if no value yet
    hexFlag=1;
    printf("h");
    continue;
    }
  if(charsRead==4){
    charsRead--;
    continue;
    }
  if(input[charsRead]=='-'){ // set neg
    charsRead--;
    if(charsRead > -1) continue; // only at start
    if(negFlag==1) continue; // once is enough
    negFlag=1;
    printf("-");
    continue;
    }
  if(input[charsRead] > 96 && input[charsRead] < 103)
    input[charsRead] -= 32; // a-f -> A-F
  if(input[charsRead] > 64 && input[charsRead] < 71){
    printf("%c",input[charsRead]);
    continue;
    }
  if(input[charsRead] > 47 && input[charsRead] < 58){
    printf("%c",input[charsRead]);
    continue;
    }
  charsRead--;
  }

  if(hexFlag==0){
    for(x=0; x<charsRead; x++){
      if(input[x] > 64 && input[x] < 71){
	hexFlag=1;
	break;
	}
      }
    }

  for(x=0; x < charsRead; x++){ 
    if(hexFlag==1) value *= 16;
    else value *= 10;
    if(input[x] > 47 && input[x] < 58){// digit 0-9
      value += (input[x] - 48);
      }
    if(input[x] > 64 && input[x] < 71){ // hex digit A-F
      value += (input[x] - 55);
      }
    }

  if(negFlag==1) value = (-value);

  //printf("\n%li",value);
  return value;
  }